import 'package:blocstar/ActionState.dart';
import 'package:blocstar/BlocContextBase.dart';
import 'package:blocstar/DataManagement/Mergeable.dart';

class CounterContext extends BlocContextBase<CounterContext> {
  final int count;
  final String description;

  CounterContext(
      {this.count,
      this.description,
      Function(ActionState<CounterContext>, CounterContext) onContextChanged})
      : super(onContextChanged);

  @override
  merge({int newCount, String newDescription}) {
    final newModel = new CounterContext(
        count: resolveValue(count, newCount),
        description: resolveValue(description, newDescription));
    mergeAppState(newModel);
    onContextChanged(newModel.actionState, newModel);
  }
}
